#if !defined(AFX_SCREENWINDOWCTL_H__1A69B98C_B062_11D1_B21A_006008279A49__INCLUDED_)
#define AFX_SCREENWINDOWCTL_H__1A69B98C_B062_11D1_B21A_006008279A49__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afxmt.h>

// ScreenWindowCtl.h : Declaration of the CScreenWindowCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CScreenWindowCtrl : See ScreenWindowCtl.cpp for implementation.

class CScreenWindowCtrl : public COleControl
{
	DECLARE_DYNCREATE(CScreenWindowCtrl)

// Constructor
public:
	CScreenWindowCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScreenWindowCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	virtual BOOL OnGetNaturalExtent(DWORD dwAspect, LONG lindex, DVTARGETDEVICE* ptd, HDC hicTargetDev, DVEXTENTINFO* pExtentInfo, LPSIZEL psizel);
//	virtual BOOL OnSetObjectRects(LPCRECT lpRectPos, LPCRECT lpRectClip);
	virtual BOOL OnSetExtent(LPSIZEL lpSizeL);
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL SetPos(long row, long column);
	~CScreenWindowCtrl();

	DECLARE_OLECREATE_EX(CScreenWindowCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CScreenWindowCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CScreenWindowCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CScreenWindowCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CScreenWindowCtrl)
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CScreenWindowCtrl)
	long m_rows;
	afx_msg void OnRowsChanged();
	long m_columns;
	afx_msg void OnColumnsChanged();
	CString m_aboutText;
	afx_msg void OnAboutTextChanged();
	long m_inputLength;
	afx_msg void OnInputLengthChanged();
	short m_tabSpace;
	afx_msg void OnTabSpaceChanged();
	long curRow;
	afx_msg void OnCurRowChanged();
	long curColumn;
	afx_msg void OnCurColumnChanged();
	OLE_COLOR m_textColor;
	afx_msg void OnTextColorChanged();
	OLE_COLOR m_textBackgroundColor;
	afx_msg void OnTextBackgroundColorChanged();
	long SCR_X;
	afx_msg void OnFontWidthChanged();
	long SCR_Y;
	afx_msg void OnFontHeightChanged();
	afx_msg BOOL KbHit();
	afx_msg BOOL DisplayAbout();
	afx_msg BOOL ClearInput();
	afx_msg BOOL ClearLine();
	afx_msg BOOL ClearScr();
	afx_msg BOOL Write(LPCTSTR str);
	afx_msg BOOL WriteLine(LPCTSTR str);
	afx_msg BOOL ReadLineAsync();
	afx_msg short ReadByte(BOOL readToEoln);
	afx_msg BSTR ReadLine();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CScreenWindowCtrl)
	void FireReadLineDone(LPCTSTR str)
		{FireEvent(eventidOnReadLineDone,EVENT_PARAM(VTS_BSTR), str);}
	void FireLoadFinished()
		{FireEvent(eventidOnLoadFinished,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CScreenWindowCtrl)
	dispidRows = 1L,
	dispidColumns = 2L,
	dispidAboutText = 3L,
	dispidInputLength = 4L,
	dispidTabSpace = 5L,
	dispidCurRow = 6L,
	dispidCurColumn = 7L,
	dispidTextColor = 8L,
	dispidTextBackgroundColor = 9L,
	dispidFontWidth = 10L,
	dispidFontHeight = 11L,
	dispidKbHit = 12L,
	dispidDisplayAbout = 13L,
	dispidClearInput = 14L,
	dispidClearLine = 15L,
	dispidClearScr = 16L,
	dispidWrite = 17L,
	dispidWriteLine = 18L,
	dispidReadLineAsync = 19L,
	dispidReadByte = 20L,
	dispidReadLine = 21L,
	eventidOnReadLineDone = 1L,
	eventidOnLoadFinished = 2L,
	//}}AFX_DISP_ID
	};
private:
	bool internalWrite(LPCTSTR str);
	CMutex *inputMutex;
	CMutex *screenMutex;
	long prevColumns;
	long prevRows;
	BOOL inPosSet;
	BOOL windowOn;
	UINT CARETID;
	UINT STARTUPID;
	CFont *pFont;
	long getLastCharPos(LPCTSTR line);
	BOOL WaitForChar(void);
	void WaitForEoln(void);
	BOOL asyncRead;
	void FreeAllocation();
//	long SCR_Y;
//	long SCR_X;
	void ChangeAllocation(long rows, long columns);
	void SetCaretState(BOOL state, BOOL on);
	void makePalette(CPalette *pal);
	CPalette pPalette;
	LPSTR scrIn;
	HGLOBAL hscrIn;
	LPCOLORINFO ** color;
	LPSTR * scr;
	BOOL caretHide;
	BOOL caretActive;
	BOOL caretStatus;
	long inRow;
	long inColumn;
	BOOL echoChars;
	COLORINFO curColor;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCREENWINDOWCTL_H__1A69B98C_B062_11D1_B21A_006008279A49__INCLUDED)
